<!DOCTYPE html>
<html lang="pt-br">
  <head>
    <title>Redes 2 - Trabalho Final</title>
    <meta charset="utf-8">
    <link rel="stylesheet" href="https://bootswatch.com/4/slate/bootstrap.min.css" crossorigin="anonymous">
    <style>
      .spoiler {
        display: inline;
        position: relative;
      }

      .spoiler-btn {
        cursor: pointer;
      }

      .hide {
        display: none;
      }

      .spoiler-body {
        padding: 6px;
      }
    </style>
    <script src="https://code.jquery.com/jquery-3.3.1.min.js" integrity="sha256-FgpCb/KJQlLNfOu91ta32o/NMZxltwRo8QtmkMRdAu8=" crossorigin="anonymous"></script>
    <script src="http://netdna.bootstrapcdn.com/bootstrap/3.0.0/js/bootstrap.min.js" crossorigin="anonymous"></script>
    <script>
        $.fn.ready(function() {
            $(document).on('click', '.spoiler-btn', function (e) {
                e.preventDefault();
                $(this).parent().children('.spoiler-body').collapse('toggle');
                $(this).parent().children('.hide').toggle();
                $(this).parent().children('.show').toggle();
            });
        });
      </script>
  </head>
  <body>
    <div class="container mt-4">
      <div class="text-center">
        <h1>Redes 2 - Trabalho Final</h1>
      </div>
        <h2>Acesso aos serviços:</h2>
        <ul>
            <li><a href="/postfix">postfix</a> - <a href="/roundcube">roundcube</a></li>  
            <li><a href="sftp://192.168.33.16">SFTP</a> ("vagrant":"vagrant")</li>
            <li><a href="/ssh">SSH</a> (ssh -p 22 vagrant@192.168.33.16)</li>
            <li><a href="/vsftpd">vsftpd</a></li>            
            <li><a href="/squid">Squid</a></li>
            <li><a href="smb://192.168.33.16">samba</a> ("bemsegura":"bemsegura")</li>            
        </ul>
        <br>
        <h2>Políticas de Segurança</h2>
        <h4>Gerenciador de e-mail</h4>
        <ol>
          <li>não enviar anexos com extensões <code>bat, com, exe, dll, vbs</code>.
            <div class="spoiler">
                <a href="#" class="spoiler-btn show">mais</a>
                <a href="#" class="spoiler-btn hide">menos</a>
                <div class="spoiler-body collapse">  
                  Foi implementado adicionando o trecho <code>mime_header_checks = regexp:/etc/postfix/mime_header_checks</code> no arquivo <code>modules/postfix/files/main.cf</code>. O arquivo, que contém apenas <code>/name=[^>]*\.(bat|com|exe|dll|vbs)/ REJECT</code> é um regex que recusa as extensões mencionadas.
                  <br>
                  Para testar, basta tentar enviar um e-mail com um anexo das extensões supracitadas.
                </div>
            </div>
          </li>
          <li>não enviar anexos maiores do que 2MB
            <div class="spoiler">
                <a href="#" class="spoiler-btn show">mais</a>
                <a href="#" class="spoiler-btn hide">menos</a>
                <div class="spoiler-body collapse">  
                  Foi implementado adicionando o trecho <code>message_size_limit=524288</code> no arquivo <code>modules/postfix/files/main.cf</code>, que define o tamanho máximo da mensagem para 5 MB.
                  <br>
                  Para testar, basta tentar enviar um e-mail com anexos que totalizem mais de 5MB.
                </div>
            </div>
          </li>
          <li>não enviar para mais de 5 destinatários ao mesmo tempo
              <div class="spoiler">
                  <a href="#" class="spoiler-btn show">mais</a>
                  <a href="#" class="spoiler-btn hide">menos</a>
                  <div class="spoiler-body collapse">  
                    Foi implementado adicionando o trecho <code>smtpd_recipient_limit = 5</code> no arquivo <code>modules/postfix/files/main.cf</code>, que define o número máximo de recipientes da mensagem para 5.
                    <br>
                    Para testar, basta tentar enviar um e-mail com mais de 5 destinatários.
                  </div>
              </div>
          </li>
        </ol>

        <h4>FTP</h4>
        <ol>
          <li>limitar a velocidade de upload para até 5Mb/s
            <div class="spoiler">
                <a href="#" class="spoiler-btn show">mais</a>
                <a href="#" class="spoiler-btn hide">menos</a>
                <div class="spoiler-body collapse">  
                  Foi implementado exeutando o código <code>sudo tc qdisc add dev eth1 root tbf rate 1mbit burst 1024kbit latency 20ms</code> que tem como objetivo adicionar um controle de tráfico no sistema por completo.
                  não conseguimos fazer com que o limite de banda funcionasse apenas para o serviço ftp, entao concordamos que um limite globar de velocidade seria adicionado.
                  O limite de velocidade de download foi estabelecido em pouca mais de 1mb/s.
                  <br>
                  Para testar, basta tentar enviar um arquivo de alguns MB/s e observar a velocidade máxima do upload.
                </div>
            </div>
          </li>
          <li>não permitir upload de arquivos com extensões <code>.mp3 e .mov</code>
            <div class="spoiler">
                <a href="#" class="spoiler-btn show">mais</a>
                <a href="#" class="spoiler-btn hide">menos</a>
                <div class="spoiler-body collapse">  
                  Foi implementado adicionando o trecho <code>deny_file={*.mp3,*.mov}</code> no arquivo <code>vsftpd.conf</code>, que define <i>patterns</i> para nomes de arquivos que deverão ser ignorados pelo servidor.
                  <br>
                  Para testar, basta tentar enviar um arquivo com extensão .mp3 (tem de ser MP3 de fato, não basta apenas alterar a extensão).
                </div>
            </div>
          </li>
          <li>não permitir mais de 2 clientes simultâneos de IPs diferentes
              <div class="spoiler">
                  <a href="#" class="spoiler-btn show">mais</a>
                  <a href="#" class="spoiler-btn hide">menos</a>
                  <div class="spoiler-body collapse">  
                    Foi implementado adicionando os trechos <code>max_clients=2</code> e <code>max_per_ip=1</code> no arquivo <code>vsftpd.conf</code>, que definem, respectivamente, o número máximo de clientes que podem ser conectados ao servidor, e o número máximo de conexões para um mesmo endereço de IP.
                    <br>
                    Para testar o número máximo de conexões por IP, basta tentar iniciar duas instâncias simultâneas do cliente SFTP, então o servidor bloqueará a segunda conexão.
                    Para testar o número máximo de conexões no total, são necessárias 3 interfaces de rede, onde cada uma conectará um cliente com IP diferente. Também é possível remover o trecho <code>max_per_ip=1</code> das configurações do servidor, reiniciá-lo e então tentar criar 3 novas conexões a partir do mesmo endereço de IP.
                  </div>
              </div>
          </li>
          <li>não permitir acesso ftp, apenas sftp
              <div class="spoiler">
                  <a href="#" class="spoiler-btn show">mais</a>
                  <a href="#" class="spoiler-btn hide">menos</a>
                  <div class="spoiler-body collapse">  
                    Foi implementado adicionando os trechos <code>ssl_enable=YES</code> e <code>force_local_logins_ssl=YES</code> no arquivo <code>vsftpd.conf</code>, que, respectivamente, habilita conexões SSL, e força que todas as conexões locais utilizem SSL.
                    <br>
                    Para testar basta iniciar o cliente e tentar conectar com o protocolo ftp:// e posteriormente sftp://.
                  </div>
              </div>
          </li>
        </ol>

        <h4>SSH</h4>
        <ol>
          <li>não permitir mais de <code>2</code> usuários simultâneos
            <div class="spoiler">
                <a href="#" class="spoiler-btn show">mais</a>
                <a href="#" class="spoiler-btn hide">menos</a>
                <div class="spoiler-body collapse">  
                  Foi implementado adicionando o trecho <code>MaxSessions 2</code> no arquivo <code>sshd_config</code> que define o número máximo de sessões ativas para SSH.
                  <br>
                  Para testar basta tentar iniciar mais de duas conexões simultâneas com o servidor.
                </div>
            </div>
          </li>
          <li>não permitir mais de <code>2</code> tentativas na senha
            <div class="spoiler">
                <a href="#" class="spoiler-btn show">mais</a>
                <a href="#" class="spoiler-btn hide">menos</a>
                <div class="spoiler-body collapse">  
                  Foi implementado adicionando o trecho <code>MaxAuthTries 2</code> no arquivo <code>sshd_config</code> que define o número máximo de tentativas de login.
                  <br>
                  Para testar basta tentar acessar o servidor via SSH três vezes com a senha errada. A terceira tentativa será bloqueada.
                </div>
            </div>
          </li>
        </ol>
        <h4>Samba</h4>
        <ol>
          <li>limitado a <code>10</code> shares por usuário
            <div class="spoiler">
                <a href="#" class="spoiler-btn show">mais</a>
                <a href="#" class="spoiler-btn hide">menos</a>
                <div class="spoiler-body collapse">  
                  Foi implementado adicionando o trecho <code>usershare max shares = 10</code> no arquivo <code>smb.config</code> que define o número máximo de shares por usuário.
                  <br>
                  Para testar basta tentar mover mais de 10 arquivos para o diretorio.
                </div>
            </div>
          </li>
          <li>usuarios não podem acessar de forma publica
            <div class="spoiler">
                <a href="#" class="spoiler-btn show">mais</a>
                <a href="#" class="spoiler-btn hide">menos</a>
                <div class="spoiler-body collapse">  
                  Foi implementado retirando o trecho <code>guest ok = no</code> no arquivo <code>smb.config</code> de todas as pastas que ali estão definidas.
                <br>
                  Para testar basta tentar acessar de forma anonima.
                </div>
            </div>
          </li>
        </ol>

        <h4>Squid</h4>
        <ol>
          Para efetuar o teste do squid antes rode no terminal do box <code>export http_proxy=http://localhost:3128 </code> para setar proxy 
          dentro do lynx , para retirar o proxy utilize <code> export http_proxy=</code>
          <li>não permitir acesso às redes sociais <code>facebook, twitter, reddit</code>
            <div class="spoiler">
                <a href="#" class="spoiler-btn show">mais</a>
                <a href="#" class="spoiler-btn hide">menos</a>
                <div class="spoiler-body collapse">  
                  Foi implementado adicionando as URLs das redes sociais no arquivo <code>modules/squid/files/redes_sociais.txt</code>. Este, por sua vez, é lido conforme as configurações do arquivo <code>modules/squid/files/squid.conf</code> e cria uma ACL proibindo os termos do arquivo.
                  <br>
                  Para testar basta tentar acessar o servidor via SSH e tentar carregar uma das redes sociais via navegador lynx.
                </div>
            </div>
          </li>
          <li>não permitir acesso aos sites <code>pornhub</code> e <code>xvideos</code>
            <div class="spoiler">
                <a href="#" class="spoiler-btn show">mais</a>
                <a href="#" class="spoiler-btn hide">menos</a>
                <div class="spoiler-body collapse">  
                  Foi implementado adicionando as URLs dos sites no arquivo <code>modules/squid/files/sites_porno.txt</code>. Este, por sua vez, é lido conforme as configurações do arquivo <code>modules/squid/files/squid.conf</code> e cria uma ACL proibindo os termos do arquivo.
                  <br>
                  Para testar basta tentar acessar o servidor via SSH e tentar carregar um dos sites via navegador lynx.
                </div>
            </div>
          </li>
          <li>não permitir acesso a sites relacionados a <code>comunismo</code> ou <code>ditadura</code>
            <div class="spoiler">
                <a href="#" class="spoiler-btn show">mais</a>
                <a href="#" class="spoiler-btn hide">menos</a>
                <div class="spoiler-body collapse">  
                  Foi implementado adicionando os termos no arquivo <code>modules/squid/files/palavras_bloqueadas.txt</code>. Este, por sua vez, é lido conforme as configurações do arquivo <code>modules/squid/files/squid.conf</code> e cria uma ACL proibindo os termos do arquivo.
                  <br>
                  Para testar basta tentar acessar o servidor via SSH e tentar pesquisar por um dos termos no Google via navegador lynx.
                </div>
            </div>
          </li>
          <li>os logs devem ser salvos no FTP (<code>/home/vagrant/logs)</code>
            <div class="spoiler">
                <a href="#" class="spoiler-btn show">mais</a>
                <a href="#" class="spoiler-btn hide">menos</a>
                <div class="spoiler-body collapse">  
                  Foi implementado alterando o trecho <code>cache_access_log /home/vagrant/logs/squid3/access.log</code> no arquivo <code>modules/squid/files/squid.conf</code>, o que altera o arquivo onde serão gravados os logs, apontando para uma pasta acessível via FTP.
                  <br>
                  Para testar basta tentar acessar o servidor via FTP e localizar o arquivo supracitado, um simples comando <code>cat</code> irá escrever o arquivo no terminal.
                </div>
            </div>
          </li>
        </ol>
  </body>
</html>